JmolPanel
Date: 2019-10-22

org.openscience.jmol.app.jmolpanel

## Class JmolPanel

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - org.openscience.jmol.app.jmolpanel.JmolPanel

- All Implemented Interfaces:
    java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, javax.accessibility.Accessible, JsonNioClient, SplashInterface
  Direct Known Subclasses:
    Jmol

      public class JmolPanel
      extends javax.swing.JPanel
      implements SplashInterface, JsonNioClient

  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `(package private) class` | `JmolPanel.AboutAction`
    `private static class` | `JmolPanel.ActionChangedListener`
    `private class` | `JmolPanel.AnimButton`
    `protected class` | `JmolPanel.AppCloser` To shutdown when run as an application.
    `(package private) class` | `JmolPanel.AtomSetChooserAction`
    `(package private) class` | `JmolPanel.CloseAction`
    `(package private) class` | `JmolPanel.ConsoleAction`
    `(package private) class` | `JmolPanel.CopyImageAction` An Action to copy the current image into the clipboard.
    `(package private) class` | `JmolPanel.CopyScriptAction`
    `(package private) class` | `JmolPanel.CreditsAction`
    `(package private) class` | `JmolPanel.ExecuteScriptAction`
    `(package private) class` | `JmolPanel.ExitAction`
    `(package private) class` | `JmolPanel.ExportAction`
    `(package private) class` | `JmolPanel.GaussianAction`
    `(package private) class` | `JmolPanel.NewAction`
    `(package private) class` | `JmolPanel.NewwinAction`
    `(package private) class` | `JmolPanel.OpenAction`
    `(package private) class` | `JmolPanel.OpenMolAction`
    `(package private) class` | `JmolPanel.OpenPdbAction`
    `(package private) class` | `JmolPanel.OpenUrlAction`
    `(package private) class` | `JmolPanel.PasteClipboardAction`
    `(package private) class` | `JmolPanel.PovrayAction`
    `(package private) class` | `JmolPanel.PrintAction`
    `(package private) class` | `JmolPanel.RecentFilesAction`
    `(package private) class` | `JmolPanel.ResizeAction`
    `(package private) class` | `JmolPanel.ScriptEditorAction`
    `(package private) class` | `JmolPanel.ScriptWindowAction`
    `(package private) class` | `JmolPanel.SurfaceToolAction`
    `(package private) class` | `JmolPanel.ToWebAction`
    `(package private) class` | `JmolPanel.UguideAction`
    `(package private) class` | `JmolPanel.ViewMeasurementTableAction`
    `(package private) class` | `JmolPanel.WhatsNewAction`
    `(package private) class` | `JmolPanel.WriteAction`

    - ### Nested classes/interfaces inherited from class javax.swing.JPanel

      `javax.swing.JPanel.AccessibleJPanel`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static java.lang.String` | `aboutAction`
    `protected java.lang.String` | `appletContext`
    `protected AtomSetChooser` | `atomSetChooser`
    `private static java.lang.String` | `atomsetchooserAction`
    `private static BannerFrame` | `bannerFrame`
    `(package private) static java.lang.String` | `chemFileProperty`
    `private static java.lang.String` | `closeAction`
    `private java.util.Map<java.lang.String,javax.swing.Action>` | `commands`
    `private static java.lang.String` | `consoleAction`
    `protected javax.swing.JFrame` | `consoleframe`
    `private JmolPanel.CopyImageAction` | `copyImageAction`
    `private static java.lang.String` | `copyImageActionProperty`
    `private JmolPanel.CopyScriptAction` | `copyScriptAction`
    `private static java.lang.String` | `copyScriptActionProperty`
    `private static java.lang.String` | `creditsAction`
    `private javax.swing.Action[]` | `defaultActions` Actions defined by the Jmol class
    `protected DisplayPanel` | `display`
    `private static java.lang.String` | `EDITOR_WINDOW_NAME`
    `private static java.lang.String` | `editorAction`
    `private JmolPanel.ExecuteScriptAction` | `executeScriptAction`
    `private static java.lang.String` | `exitAction`
    `private JmolPanel.ExportAction` | `exportAction`
    `private static java.lang.String` | `exportActionProperty`
    `private static java.lang.String` | `FILE_OPEN_WINDOW_NAME`
    `javax.swing.JFrame` | `frame`
    `private static java.lang.String` | `gaussianAction`
    `protected GaussianDialog` | `gaussianDialog`
    `GuiMap` | `guimap`
    `protected static HistoryFile` | `historyFile`
    `(package private) static java.lang.String[]` | `imageChoices`
    `(package private) static java.lang.String[]` | `imageExtensions`
    `protected java.lang.String` | `imageType`
    `(package private) JmolApp` | `jmolApp`
    `private static KioskFrame` | `kioskFrame`
    `private java.util.Map<java.lang.String,javax.swing.JMenuItem>` | `menuItems`
    `(package private) JmolAdapter` | `modelAdapter`
    `private StatusListener` | `myStatusListener`
    `private static java.lang.String` | `newAction`
    `private static java.lang.String` | `newwinAction`
    `private static int` | `numWindows`
    `private static java.lang.String` | `openAction`
    `private static java.lang.String` | `openmolAction`
    `private static java.lang.String` | `openpdbAction`
    `private static java.lang.String` | `openurlAction`
    `private JmolPanel.PasteClipboardAction` | `pasteClipboardAction`
    `private static java.lang.String` | `pasteClipboardActionProperty`
    `protected java.beans.PropertyChangeSupport` | `pcs`
    `protected static HistoryFile` | `pluginFile`
    `(package private) javax.swing.JMenu` | `pluginMenu`
    `(package private) java.util.Map<java.lang.String,JmolPlugin>` | `plugins`
    `private JmolPanel.PovrayAction` | `povrayAction`
    `private static java.lang.String` | `povrayActionProperty`
    `(package private) PreferencesDialog` | `preferencesDialog`
    `private JmolPanel.PrintAction` | `printAction`
    `private static java.lang.String` | `printActionProperty`
    `protected int` | `qualityJPG`
    `protected int` | `qualityPNG`
    `protected RecentFilesDialog` | `recentFiles`
    `private static java.lang.String` | `recentFilesAction`
    `private static java.lang.String` | `resizeAction`
    `private static java.awt.Dimension` | `screenSize`
    `private static java.lang.String` | `SCRIPT_WINDOW_NAME`
    `(package private) JsonNioServer` | `serverService`
    `protected JsonNioServer` | `service`
    `protected SplashInterface` | `splash`
    `(package private) int` | `startupHeight`
    `(package private) int` | `startupWidth`
    `(package private) StatusBar` | `status`
    `private SurfaceTool` | `surfaceTool`
    `private static java.lang.String` | `SURFACETOOL_WINDOW_NAME`
    `private JmolPanel.SurfaceToolAction` | `surfaceToolAction`
    `private static java.lang.String` | `surfaceToolActionProperty`
    `private javax.swing.JToolBar` | `toolbar`
    `private JmolPanel.ToWebAction` | `toWebAction`
    `private static java.lang.String` | `toWebActionProperty`
    `private static java.lang.String` | `uguideAction`
    `private JmolPanel.ViewMeasurementTableAction` | `viewMeasurementTableAction`
    `Viewer` | `vwr`
    `(package private) java.util.Map<java.lang.String,java.lang.Object>` | `vwrOptions`
    `private static java.lang.String` | `WEB_MAKER_WINDOW_NAME`
    `(package private) WebExport` | `webExport`
    `private static java.lang.String` | `whatsnewAction`
    `private JmolPanel.WriteAction` | `writeAction`
    `private static java.lang.String` | `writeActionProperty`

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JmolPanel(JmolApp jmolApp, Splash splash, javax.swing.JFrame frame, JmolPanel parent, int startupWidth, int startupHeight, java.util.Map<java.lang.String,java.lang.Object> vwrOptions, java.awt.Point loc)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `private void` | `addHelpMenuBar(javax.swing.JMenuBar menuBar)`
    `private void` | `addMacrosMenu(javax.swing.JMenuBar menuBar)`
    `private void` | `addNormalMenuBar(javax.swing.JMenuBar menuBar)`
    `private void` | `addPluginMenu(javax.swing.JMenuBar mb)`
    `(package private) java.lang.String` | `createImageStatus(java.lang.String fileName, java.lang.String type, java.lang.Object text_or_bytes, int quality)` Starting with Jmol 11.8.RC5, this is just informational if type == null and null is returned, then it means "Jmol, you handle it"
    `(package private) javax.swing.JMenu` | `createMenu(java.lang.String key)` Create a menu for the app.
    `private javax.swing.JMenuBar` | `createMenubar()` Create the menubar for the app.
    `private javax.swing.JMenuItem` | `createMenuItem(java.lang.String cmd)` This is the hook through which all menu items are created.
    `(package private) void` | `createSurfaceTool()`
    `protected java.awt.Component` | `createTool(java.lang.String key)` Hook through which every toolbar item is created.
    `private javax.swing.JToolBar` | `createToolbar()` Create the toolbar.
    `protected javax.swing.AbstractButton` | `createToolbarButton(java.lang.String key)` Create a button to go inside of the toolbar.
    `(package private) void` | `createWebExport()`
    `(package private) void` | `dispose(javax.swing.JFrame f, boolean saveSize)`
    `protected boolean` | `doClose(boolean saveSize)`
    `(package private) void` | `doNew()`
    `protected javax.swing.Action` | `getAction(java.lang.String cmd)` Fetch the action that was created for the given command.
    `java.util.List<javax.swing.Action>` | `getActions()`
    `private JmolPlugin` | `getAndRegisterPlugin(java.lang.String name, java.lang.String path)`
    `private void` | `getDialogs()`
    `static java.lang.Object` | `getInstanceWithParams(java.lang.String name, java.lang.Class<?>[] classes, java.lang.Object... params)`
    `private static void` | `getJavaConsole(Jmol jmol)`
    `static Jmol` | `getJmol(JmolApp jmolApp, javax.swing.JFrame frame)`
    `static java.lang.String` | `getJmolProperty(java.lang.String key, java.lang.String defaultValue)`
    `static JsonNioServer` | `getJsonNioServer()`
    `protected javax.swing.JMenuItem` | `getMenuItem(java.lang.String cmd)` Fetch the menu item that was created for the given command.
    `static java.lang.String` | `getPluginOption(java.lang.String pluginName, java.lang.String key, java.lang.String defaultValue)`
    `java.lang.Object` | `getPreference(java.lang.String key)`
    `static java.io.File` | `getUserDirectory()` Returns a new File referenced by the property 'user.dir', or null if the property is not defined.
    `void` | `nioClosed(JsonNioServer jns)`
    `void` | `nioRunContent(JsonNioServer jns)`
    `(package private) void` | `notifyFileOpen(java.lang.String fullPathName, java.lang.String title)`
    `(package private) void` | `openFile()`
    `void` | `print()` added print command, so that it can be used by RasmolScriptHandler
    `private void` | `report(java.lang.String str)`
    `(package private) void` | `resizeDisplay(int width, int height)`
    `(package private) int[]` | `resizeInnerPanel(java.lang.String data)`
    `(package private) void` | `saveWindowSizes()`
    `(package private) void` | `say(java.lang.String message)`
    `(package private) void` | `sendNioMessage(int port, java.lang.String strInfo)`
    `void` | `setBannerLabel(java.lang.String label)`
    `(package private) void` | `setMenuNBO(javax.swing.JMenu item)`
    `(package private) void` | `setMenuState()`
    `static void` | `setPluginOption(java.lang.String pluginName, java.lang.String key, java.lang.String value)`
    `(package private) void` | `showPlugin(java.lang.String name, java.lang.String path, java.util.Map<java.lang.String,java.lang.Object> jmolOptions)`
    `void` | `showStatus(java.lang.String message)`
    `protected static void` | `startJmol(JmolApp jmolApp)`
    `(package private) void` | `startNBO(java.util.Map<java.lang.String,java.lang.Object> jmolOptions)`
    `void` | `syncScript(java.lang.String script)`
    `void` | `updateConsoleFont()`
    `(package private) void` | `updateLabels()`

    - ### Methods inherited from class javax.swing.JPanel

      `getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### historyFile

          protected static HistoryFile historyFile

    - #### pluginFile

          protected static HistoryFile pluginFile

    - #### vwr

          public Viewer vwr

    - #### modelAdapter

          JmolAdapter modelAdapter

    - #### jmolApp

          JmolApp jmolApp

    - #### status

          StatusBar status

    - #### startupWidth

          int startupWidth

    - #### startupHeight

          int startupHeight

    - #### serverService

          JsonNioServer serverService

    - #### appletContext

          protected java.lang.String appletContext

    - #### pcs

          protected java.beans.PropertyChangeSupport pcs

    - #### display

          protected DisplayPanel display

    - #### gaussianDialog

          protected GaussianDialog gaussianDialog

    - #### recentFiles

          protected RecentFilesDialog recentFiles

    - #### atomSetChooser

          protected AtomSetChooser atomSetChooser

    - #### frame

          public javax.swing.JFrame frame

    - #### splash

          protected SplashInterface splash

    - #### consoleframe

          protected javax.swing.JFrame consoleframe

    - #### service

          protected JsonNioServer service

    - #### qualityJPG

          protected int qualityJPG

    - #### qualityPNG

          protected int qualityPNG

    - #### imageType

          protected java.lang.String imageType

    - #### guimap

          public GuiMap guimap

    - #### executeScriptAction

          private JmolPanel.ExecuteScriptAction executeScriptAction

    - #### preferencesDialog

          PreferencesDialog preferencesDialog

    - #### myStatusListener

          private StatusListener myStatusListener

    - #### surfaceTool

          private SurfaceTool surfaceTool

    - #### commands

          private java.util.Map<java.lang.String,javax.swing.Action> commands

    - #### menuItems

          private java.util.Map<java.lang.String,javax.swing.JMenuItem> menuItems

    - #### toolbar

          private javax.swing.JToolBar toolbar

    - #### exportAction

          private JmolPanel.ExportAction exportAction

    - #### povrayAction

          private JmolPanel.PovrayAction povrayAction

    - #### toWebAction

          private JmolPanel.ToWebAction toWebAction

    - #### writeAction

          private JmolPanel.WriteAction writeAction

    - #### printAction

          private JmolPanel.PrintAction printAction

    - #### copyImageAction

          private JmolPanel.CopyImageAction copyImageAction

    - #### copyScriptAction

          private JmolPanel.CopyScriptAction copyScriptAction

    - #### surfaceToolAction

          private JmolPanel.SurfaceToolAction surfaceToolAction

    - #### pasteClipboardAction

          private JmolPanel.PasteClipboardAction pasteClipboardAction

    - #### viewMeasurementTableAction

          private JmolPanel.ViewMeasurementTableAction viewMeasurementTableAction

    - #### vwrOptions

          java.util.Map<java.lang.String,java.lang.Object> vwrOptions

    - #### numWindows

          private static int numWindows

    - #### kioskFrame

          private static KioskFrame kioskFrame

    - #### bannerFrame

          private static BannerFrame bannerFrame

    - #### EDITOR_WINDOW_NAME

          private static final java.lang.String EDITOR_WINDOW_NAME

      See Also:
        Constant Field Values

    - #### SCRIPT_WINDOW_NAME

          private static final java.lang.String SCRIPT_WINDOW_NAME

      See Also:
        Constant Field Values

    - #### FILE_OPEN_WINDOW_NAME

          private static final java.lang.String FILE_OPEN_WINDOW_NAME

      See Also:
        Constant Field Values

    - #### WEB_MAKER_WINDOW_NAME

          private static final java.lang.String WEB_MAKER_WINDOW_NAME

      See Also:
        Constant Field Values

    - #### SURFACETOOL_WINDOW_NAME

          private static final java.lang.String SURFACETOOL_WINDOW_NAME

      See Also:
        Constant Field Values

    - #### screenSize

          private static final java.awt.Dimension screenSize

    - #### newwinAction

          private static final java.lang.String newwinAction

      See Also:
        Constant Field Values

    - #### openAction

          private static final java.lang.String openAction

      See Also:
        Constant Field Values

    - #### openurlAction

          private static final java.lang.String openurlAction

      See Also:
        Constant Field Values

    - #### openpdbAction

          private static final java.lang.String openpdbAction

      See Also:
        Constant Field Values

    - #### openmolAction

          private static final java.lang.String openmolAction

      See Also:
        Constant Field Values

    - #### newAction

          private static final java.lang.String newAction

      See Also:
        Constant Field Values

    - #### exportActionProperty

          private static final java.lang.String exportActionProperty

      See Also:
        Constant Field Values

    - #### closeAction

          private static final java.lang.String closeAction

      See Also:
        Constant Field Values

    - #### exitAction

          private static final java.lang.String exitAction

      See Also:
        Constant Field Values

    - #### aboutAction

          private static final java.lang.String aboutAction

      See Also:
        Constant Field Values

    - #### whatsnewAction

          private static final java.lang.String whatsnewAction

      See Also:
        Constant Field Values

    - #### creditsAction

          private static final java.lang.String creditsAction

      See Also:
        Constant Field Values

    - #### uguideAction

          private static final java.lang.String uguideAction

      See Also:
        Constant Field Values

    - #### printActionProperty

          private static final java.lang.String printActionProperty

      See Also:
        Constant Field Values

    - #### recentFilesAction

          private static final java.lang.String recentFilesAction

      See Also:
        Constant Field Values

    - #### povrayActionProperty

          private static final java.lang.String povrayActionProperty

      See Also:
        Constant Field Values

    - #### writeActionProperty

          private static final java.lang.String writeActionProperty

      See Also:
        Constant Field Values

    - #### editorAction

          private static final java.lang.String editorAction

      See Also:
        Constant Field Values

    - #### consoleAction

          private static final java.lang.String consoleAction

      See Also:
        Constant Field Values

    - #### toWebActionProperty

          private static final java.lang.String toWebActionProperty

      See Also:
        Constant Field Values

    - #### atomsetchooserAction

          private static final java.lang.String atomsetchooserAction

      See Also:
        Constant Field Values

    - #### copyImageActionProperty

          private static final java.lang.String copyImageActionProperty

      See Also:
        Constant Field Values

    - #### copyScriptActionProperty

          private static final java.lang.String copyScriptActionProperty

      See Also:
        Constant Field Values

    - #### surfaceToolActionProperty

          private static final java.lang.String surfaceToolActionProperty

      See Also:
        Constant Field Values

    - #### pasteClipboardActionProperty

          private static final java.lang.String pasteClipboardActionProperty

      See Also:
        Constant Field Values

    - #### gaussianAction

          private static final java.lang.String gaussianAction

      See Also:
        Constant Field Values

    - #### resizeAction

          private static final java.lang.String resizeAction

      See Also:
        Constant Field Values

    - #### plugins

          java.util.Map<java.lang.String,JmolPlugin> plugins

    - #### pluginMenu

          javax.swing.JMenu pluginMenu

    - #### defaultActions

          private javax.swing.Action[] defaultActions

      Actions defined by the Jmol class

    - #### imageChoices

          static final java.lang.String[] imageChoices

    - #### imageExtensions

          static final java.lang.String[] imageExtensions

    - #### webExport

          WebExport webExport

    - #### chemFileProperty

          static final java.lang.String chemFileProperty

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### JmolPanel

          public JmolPanel(JmolApp jmolApp,
                           Splash splash,
                           javax.swing.JFrame frame,
                           JmolPanel parent,
                           int startupWidth,
                           int startupHeight,
                           java.util.Map<java.lang.String,java.lang.Object> vwrOptions,
                           java.awt.Point loc)

  - ### Method Detail

    - #### getDialogs

          private void getDialogs()

    - #### startJmol

          protected static void startJmol(JmolApp jmolApp)

    - #### getJavaConsole

          private static void getJavaConsole(Jmol jmol)

    - #### getJmol

          public static Jmol getJmol(JmolApp jmolApp,
                                     javax.swing.JFrame frame)

    - #### showStatus

          public void showStatus(java.lang.String message)

      Specified by:
        `showStatus` in interface `SplashInterface`

    - #### report

          private void report(java.lang.String str)

    - #### say

          void say(java.lang.String message)

    - #### getActions

          public java.util.List<javax.swing.Action> getActions()

      Returns:
        A list of Actions that is understood by the upper level application

    - #### doClose

          protected boolean doClose(boolean saveSize)

    - #### dispose

          void dispose(javax.swing.JFrame f,
                       boolean saveSize)

    - #### saveWindowSizes

          void saveWindowSizes()

    - #### createMenuItem

          private javax.swing.JMenuItem createMenuItem(java.lang.String cmd)

      This is the hook through which all menu items are created. It registers the result with the menuitem hashtable so that it can be fetched with getMenuItem().
      Parameters:
        `cmd` -
      Returns:
        Menu item created
      See Also:
        `getMenuItem(java.lang.String)`

    - #### getMenuItem

          protected javax.swing.JMenuItem getMenuItem(java.lang.String cmd)

      Fetch the menu item that was created for the given command.
      Parameters:
        `cmd` - Name of the action.
      Returns:
        item created for the given command or null if one wasn't created.

    - #### getAction

          protected javax.swing.Action getAction(java.lang.String cmd)

      Fetch the action that was created for the given command.
      Parameters:
        `cmd` - Name of the action.
      Returns:
        The action

    - #### createToolbar

          private javax.swing.JToolBar createToolbar()

      Create the toolbar. By default this reads the resource file for the definition of the toolbars.
      Returns:
        The toolbar

    - #### createTool

          protected java.awt.Component createTool(java.lang.String key)

      Hook through which every toolbar item is created.
      Parameters:
        `key` -
      Returns:
        Toolbar item

    - #### createToolbarButton

          protected javax.swing.AbstractButton createToolbarButton(java.lang.String key)

      Create a button to go inside of the toolbar. By default this will load an image resource. The image filename is relative to the classpath (including the '.' directory if its a part of the classpath), and may either be in a JAR file or a separate file.
      Parameters:
        `key` - The key in the resource file to serve as the basis of lookups.
      Returns:
        Button

    - #### createMenubar

          private javax.swing.JMenuBar createMenubar()

      Create the menubar for the app. By default this pulls the definition of the menu from the associated resource file.
      Returns:
        Menubar

    - #### addPluginMenu

          private void addPluginMenu(javax.swing.JMenuBar mb)

    - #### addMacrosMenu

          private void addMacrosMenu(javax.swing.JMenuBar menuBar)

    - #### addNormalMenuBar

          private void addNormalMenuBar(javax.swing.JMenuBar menuBar)

    - #### addHelpMenuBar

          private void addHelpMenuBar(javax.swing.JMenuBar menuBar)

    - #### createMenu

          javax.swing.JMenu createMenu(java.lang.String key)

      Create a menu for the app. By default this pulls the definition of the menu from the associated resource file.
      Parameters:
        `key` -
      Returns:
        Menu created

    - #### setMenuState

          void setMenuState()

    - #### doNew

          void doNew()

    - #### setMenuNBO

          void setMenuNBO(javax.swing.JMenu item)

      Parameters:
        `item` -

    - #### startNBO

          void startNBO(java.util.Map<java.lang.String,java.lang.Object> jmolOptions)

      Parameters:
        `jmolOptions` - e.g. NOZAP;VIEWER unused

    - #### showPlugin

          void showPlugin(java.lang.String name,
                          java.lang.String path,
                          java.util.Map<java.lang.String,java.lang.Object> jmolOptions)

    - #### getAndRegisterPlugin

          private JmolPlugin getAndRegisterPlugin(java.lang.String name,
                                                  java.lang.String path)

    - #### getInstanceWithParams

          public static java.lang.Object getInstanceWithParams(java.lang.String name,
                                                               java.lang.Class<?>[] classes,
                                                               java.lang.Object... params)

    - #### print

          public void print()

      added print command, so that it can be used by RasmolScriptHandler

    - #### createImageStatus

          java.lang.String createImageStatus(java.lang.String fileName,
                                             java.lang.String type,
                                             java.lang.Object text_or_bytes,
                                             int quality)

      Starting with Jmol 11.8.RC5, this is just informational if type == null and null is returned, then it means "Jmol, you handle it"
      Parameters:
        `fileName` -
        `type` -
        `text_or_bytes` -
        `quality` -
      Returns:
        null (you do it) or a message starting with OK or an error message

    - #### createWebExport

          void createWebExport()

    - #### createSurfaceTool

          void createSurfaceTool()

    - #### getUserDirectory

          public static java.io.File getUserDirectory()

      Returns a new File referenced by the property 'user.dir', or null if the property is not defined.
      Returns:
        a File to the user directory

    - #### openFile

          void openFile()

    - #### notifyFileOpen

          void notifyFileOpen(java.lang.String fullPathName,
                              java.lang.String title)

    - #### resizeInnerPanel

          int[] resizeInnerPanel(java.lang.String data)

    - #### resizeDisplay

          void resizeDisplay(int width,
                             int height)

    - #### updateLabels

          void updateLabels()

    - #### nioRunContent

          public void nioRunContent(JsonNioServer jns)

      Specified by:
        `nioRunContent` in interface `JsonNioClient`

    - #### nioClosed

          public void nioClosed(JsonNioServer jns)

      Specified by:
        `nioClosed` in interface `JsonNioClient`

    - #### setBannerLabel

          public void setBannerLabel(java.lang.String label)

      Specified by:
        `setBannerLabel` in interface `JsonNioClient`

    - #### sendNioMessage

          void sendNioMessage(int port,
                              java.lang.String strInfo)

    - #### getJsonNioServer

          public static JsonNioServer getJsonNioServer()

    - #### syncScript

          public void syncScript(java.lang.String script)

    - #### updateConsoleFont

          public void updateConsoleFont()

    - #### getPreference

          public java.lang.Object getPreference(java.lang.String key)

    - #### getJmolProperty

          public static java.lang.String getJmolProperty(java.lang.String key,
                                                         java.lang.String defaultValue)

    - #### setPluginOption

          public static void setPluginOption(java.lang.String pluginName,
                                             java.lang.String key,
                                             java.lang.String value)

    - #### getPluginOption

          public static java.lang.String getPluginOption(java.lang.String pluginName,
                                                         java.lang.String key,
                                                         java.lang.String defaultValue)